// StretchClock 2.0 by Shane Gildnes
// (C)2006 - 2012 by FitClock Productions
// All rights reserved.
//
//
// Are you interested in this code? Do you want your own stretch reminder gadget?
// if so, you should check out StretchClock Pro, it is a product for people who need their own stretch gadgets.
//
// www.StretchClock.com/pro
//
//
// Please contact us for more info.
// www.StretchClock.com/support
//

// Constants
SC_USER_ID = 'DEFAULT_USER_WINDOWS';
SC_FIRST_STRETCH = 'http://www.stretchclock.com/more/stretch/';
SC_STRETCH_ROUTER = 'http://www.stretchclock.com/more/stretch/';

// Default Settings
DEFAULT_StretchInterval = 60;
DEFAULT_Remind = false;
DEFAULT_AskBeforeStretching = false;

var gadgetWidthDocked 		= '129px';
var gadgetHeightDocked 		= '108px';
var gadgetWidthUndocked 	= '129px'; 
var gadgetHeightUndocked	= '108px';

//var ONE_MINUTE = 60000; // milliseconds
var ONE_MINUTE = 60000; // milliseconds

// the clock countdown interval
var OneMinIntervalID;

// onreadystatechange Runs anytime there is a state change
document.onreadystatechange = function()
{   
    if(document.readyState=="complete")
    {
        System.Gadget.settingsUI = "Settings.htm";
        System.Gadget.onSettingsClosed = settingsClosed;
        initSettings(); 		

        if (System.Gadget.Settings.read("Paused") == false)
        {
    		// wakeup every 60 seconds
            OneMinIntervalID = window.setInterval(wakeup, ONE_MINUTE);


            // if it is the user's first time, then launch a stretch
            if (System.Gadget.Settings.read("TimeLastStretched") == "")
            { btnStretch_onClick(); }
        	else        	
        	{ UpdateClockDisplay(); }
        	
        }
        else
        {
            pause();
        }
    }        
}

function initSettings()
{
        if (System.Gadget.Settings.read("StretchInterval") == "")
        { System.Gadget.Settings.write("StretchInterval", DEFAULT_StretchInterval); }
        
        if (System.Gadget.Settings.read("Remind") == "")
       { System.Gadget.Settings.write("Remind", DEFAULT_Remind); }        

        if (System.Gadget.Settings.read("AskBeforeStretching") == "")
        { System.Gadget.Settings.write("AskBeforeStretching", DEFAULT_AskBeforeStretching); } 
        
        if (System.Gadget.Settings.read("Paused") == "")
        { System.Gadget.Settings.write("Paused", false); } 
        
        if (System.Gadget.Settings.read("MinsToNextStretch") == "")
        { System.Gadget.Settings.write("MinsToNextStretch", System.Gadget.Settings.read("StretchInterval")); }                 
		//Schedule
        if (System.Gadget.Settings.read("EnableSchedule") == "")
        { System.Gadget.Settings.write("EnableSchedule", false); }
		
		for (i = 2; i<7; i++)	{
			// mon - fri on by default
			if (System.Gadget.Settings.read("Work_" + i) == "")
			{ System.Gadget.Settings.write("Work_" + i, true); }		
		}
		// sunday off by default
		if (System.Gadget.Settings.read("Work_1") == "")
		{ System.Gadget.Settings.write("Work_1", false); }		
		// saturday off by default
		if (System.Gadget.Settings.read("Work_7") == "")
		{ System.Gadget.Settings.write("Work_7", false); }		

		

}

function settingsClosed() {
    // time until next stretch
    var nextStretch = System.Gadget.Settings.read("MinsToNextStretch");
    
    // time between stretches 
    var StretchInterval = System.Gadget.Settings.read("StretchInterval");

	// update display if necessary
    if (StretchInterval < nextStretch)    {
        System.Gadget.Settings.write("MinsToNextStretch", StretchInterval);
    }
	UpdateClockDisplay();
}

function wakeup()  {    
    // countdown by one minute
    var nextStretch = System.Gadget.Settings.read("MinsToNextStretch");
    nextStretch--;
    System.Gadget.Settings.write("MinsToNextStretch", nextStretch);
   
    if ((nextStretch < 1) && (!isSleeping()))	{
        timeToStretch();
    }
    UpdateClockDisplay();
}

function timeToStretch()	{
    // Time to stretch
    if (!(System.Gadget.Settings.read("AskBeforeStretching")))    {
		if (System.Gadget.Settings.read("Remind")) {remind();}
        stretch();
    }
    else    {
        //if the user has not been reminded yet
        if (System.Gadget.Settings.read("MinsToNextStretch") == 0)	{
                // animate the button
                btnStretch_Anim();
                // if the user wants an audio reminder
                if (System.Gadget.Settings.read("Remind")) { remind(); }  
            }
        // next line stops the var from running away and hogging memory
        System.Gadget.Settings.write("MinsToNextStretch", -1);
    }
}

function remind()	{
    playSound();
}

function playSound()	{
		sFile = System.Gadget.path + "\\sounds\\" + "Twang.wav";
		System.Sound.playSound(sFile);
}

function UpdateClockDisplay()  {
    var msg = "";
	if (isSleeping())	{
		msg = "sleeping";
	}
	else if (isPaused())	{
		msg = "paused";
	}
	else	{
		var MinsToNextStretch = System.Gadget.Settings.read("MinsToNextStretch");
		if (MinsToNextStretch < 1)    {
			msg = "stretch now";
		}
		else    {    
			msg = MinsToNextStretch.toString() + " minute";
			if (MinsToNextStretch > 1)	{
				// Change minute to minutes
				msg += "s";
			}
		 }
	}
    // print mins to next stretch
//	msg = isSleeping();
   document.getElementById("clockTime").innerHTML = msg;    
}

function isSleeping()	{
	// this function uses short circuit to return immediately when it knows the answer

	// if the schedule is not enabled then return false
	if (System.Gadget.Settings.read("EnableSchedule") == false)	{ return false; }

	// get current day of week
	var d = new Date();
	var dow = d.getDay();
	dow++;	

	// If Stretch on (today) is not checked then return true
	if (System.Gadget.Settings.read("Work_" + dow) == false)	{return true;}	

	// get the "on time" for today
	var on_hr = System.Gadget.Settings.read("OnHour_" + dow);
	var on_min = System.Gadget.Settings.read("OnMin_" + dow);
	var on_ampm = System.Gadget.Settings.read("OnAMPM_" + dow);
	on_hr = Get24Hour(on_hr, on_ampm);
	var on_time = new Date(d.getYear(), d.getMonth(), d.getDate(), on_hr, on_min, 0, 0);
	
	// get the "off time" for today
	var off_hr = System.Gadget.Settings.read("OffHour_" + dow);
	var off_min = System.Gadget.Settings.read("OffMin_" + dow);
	var off_ampm = System.Gadget.Settings.read("OffAMPM_" + dow);
	off_hr = Get24Hour(off_hr, off_ampm);
	var off_time = new Date(d.getYear(), d.getMonth(), d.getDate(), off_hr, off_min, 0, 0);

	if (on_time.getTime() == off_time.getTime()) {return true;}
	
	if (off_time.getTime() > on_time.getTime())	{
		// day shift
		if ((d.getTime() > on_time.getTime()) &&  (d.getTime() < off_time.getTime())) {return false;}
		else {return true};
	}			
	else	{ 
		// graveyard shift
		if ((d.getTime() > off_time.getTime()) && (d.getTime() < on_time.getTime())) {return true;}
		else {return false}
	}
	// actually we should never make it here.
	return false;	
}

function Get24Hour(scrub_hour, scrub_ampm)	{
	var hour;
	if (scrub_ampm == "AM")	{
		if (scrub_hour == 12) { hour = 0;}
		else { hour = scrub_hour;}
	}
	else	{
		// PM
		if (scrub_hour == 12) {hour = 12;}
		else {hour = scrub_hour + 12;}
	}
	return hour;
}
function openLink(url) {
//	url = url.replace(/http\:\/\//, "");
	System.Shell.execute(url,"stretchclock","stretchclock","open");
}

function btnStretch_onClick()
{
    stretch();
    UpdateClockDisplay();    
}

function btnStretch_Anim()
{
    // turn on the flashing "stretch now button"
    if (document.getElementById("btnStretchNow").src != "images/buttons/StretchNowAnim.gif")
    { 
        document.getElementById("btnStretchNow").src = "images/buttons/StretchNowAnim.gif";
    } 
}

function btnStretch_StopAnim()
{
    // reset the flashing "stretch now" button
    document.getElementById("btnStretchNow").src = "images/buttons/normal/StretchNow.png"; 
}

function stretch()
{
    // reset the clock
    System.Gadget.Settings.write("MinsToNextStretch", System.Gadget.Settings.read("StretchInterval"));

    // Stop animation
    btnStretch_StopAnim();

    // if paused
    if (System.Gadget.Settings.read("Paused") == true)    {
		// wake up
        unPause();
    }

    var urlParams = '?utm_source=Gadget&utm_medium=Windows&utm_content=stretch&utm_campaign=v2_Windows&sc_u=' + SC_USER_ID.toString();
    if (System.Gadget.Settings.read("TimeLastStretched") == "")
    {
        // launch first stretch
        openLink( SC_FIRST_STRETCH + urlParams);
    }
    else
    {
        openLink( SC_STRETCH_ROUTER + urlParams);    
    }

    // Set TimeLast Stretched
    currTime = new Date();            	
    System.Gadget.Settings.write("TimeLastStretched", currTime);

}

function btnPause_onClick()
{
    if (System.Gadget.Settings.read("Paused") == false)    {
        pause();    
    }
    else    {
        unPause();
    }    

}

function btnLater_onClick()	{
    // reset the clock
    System.Gadget.Settings.write("MinsToNextStretch", System.Gadget.Settings.read("StretchInterval"));

    if (System.Gadget.Settings.read("Paused") == true)
    {
		unPause();        
    }
    
    btnStretch_StopAnim();
    UpdateClockDisplay();
}

function pause()	{
        // Pause the clock
        document.getElementById("clockTime").innerHTML = "paused";
        btnStretch_StopAnim();
        System.Gadget.Settings.write("Paused", true);			
        window.clearInterval(OneMinIntervalID);
}

function unPause()	{
    OneMinIntervalID = window.setInterval(wakeup, ONE_MINUTE);
    System.Gadget.Settings.write("Paused", false);			

    if (System.Gadget.Settings.read("MinsToNextStretch") < 1)    {
      btnStretch_Anim();  
    }
    UpdateClockDisplay();
}

function isPaused()	{
	return (System.Gadget.Settings.read("Paused") == true) 	
}